Skip to navigation

Retrieve a debit memo

View as Markdown
Retrieve the details of a specific Debit Memo object.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

keystringRequired
Object ID or Number.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Query parameters

pageSizeintegerOptional1-99Defaults to 10

The maximum number of results to return in a single page. If the specified pageSize is less than 1 or greater than 99, Zuora will return a 400 error.

cursorstringOptional

A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with next_page=W3sib3JkZXJ=, your subsequent call can include cursor=W3sib3JkZXJ= in order to fetch the next page of the list.

sort[]list of stringsOptional

A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. accountnumber.ASC) or descending (e.g. accountnumber.DESC). You cannot sort on properties in arrays. If the array-type properties are specified for the sort[] parameter, they are ignored.

expand[]list of enumsOptional
Allows you to expand responses by including related object information in a single call.
filter[]list of stringsOptional

A case-insensitive filter on the list.

fields[]list of stringsOptional

A case-insensitive query parameter that allows you to specify which fields are returned in the response.

includeNullFieldsbooleanOptionalDefaults to false

Specifies whether to include fields with the null value in the response.

  • If set to true, all fields will be returned in the response, including those with the null value.
  • If set to false, only fields with non-null values will be returned.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
idstringOptional
The unique identifier of the debit memo.
createdByIdstringOptional
The unique identifier of the user who created the debit memo.
createdDatedatetimeOptional
The date and time when the debit memo was created.
updatedByIdstringOptional
The unique identifier of the user who last updated the debit memo.
updatedDatedatetimeOptional
The date and time when the debit memo was last updated.
autoPaybooleanOptional
Whether debit memos are automatically picked up for processing in the corresponding payment run. By default, debit memos are automatically picked up for processing in the corresponding payment run.
creditMemoIdstring or nullOptional
The ID of the credit memo from which the debit memo was created.
balancedoubleOptional
The remaining balance of debit memo.
billToContactIdstringOptional

The ID of the bill-to contact associated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

billToContactSnapshotIdstringOptional

The ID of the bill-to contact snapshot associated with the debit memo.

The value of this field is null if the bill rule Preserve snapshot of bill-to and sold-to contacts when billing documents are posted is disabled.

cancelledByIdstring or nullOptional
The ID of the Zuora user who cancelled the debit memo.
cancelledOndatetime or nullOptional

The date and time when the debit memo was cancelled, in yyyy-mm-dd hh:mm:ss format.

commentsstringOptional
Comments about the debit memo.
currencystring or nullOptional

The currency of the debit memo.

Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.

discountAmountdoubleOptional
The amount of the discount on the debit memo.
dueDatedateOptional

The date by which the payment for the debit memo is due, in yyyy-mm-dd format.

einvoiceErrorCodestringOptional

The error code returned when the e-invoice file status is Failed. This code can either be a Zuora-generated error code or one returned by a third-party e-invoicing service provider.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceErrorMessagestringOptional

The error message returned when the e-invoice file status is Failed. This message can either be a Zuora-generated error message or one returned by a third-party e-invoicing service provider.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceFileIdstringOptional

The ID of the e-invoice file generated for the debit memo.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceStatusenumOptional

The status of the e-invoice file generation for the credit memo.

  • If e-invoice file generation succeeds, this field is either Generated or Success, and both the error code and message are empty, and the eInvoiceFileId field stores the ID of the generated e-invoice file.

  • If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes RetrieveTimeOut. Once the vendor responds successfully, you can use the ‘Resync E-Invoice Status’ action to update the status automatically. You can view these updates in System Health telemetry.

  • If a failure occurs during e-invoice file generation, this field is Failed and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.

  • If e-invoice file generation conditionally succeeds, this field is ConditionalSuccess and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.

  • If the e-invoice file has been approved by the tax authority, this field is ApprovedByAuthority. The next status will be either Success or Rejected.

  • If the e-invoice file has been rejected by the government, this field is Rejected. You cannot resend this e-invoice; you must create a new invoice instead.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

exchangeRateDatedateOptional

The date of the exchange rate used. The date is in yyyy-mm-dd format. Corresponds to the value specified in the Provider Exchange Rate Date column in the Import Foreign Exchange Rates template when you uploaded the rates through the Mass Updater.

memoDatedateOptional

The date when the debit memo takes effect, in yyyy-mm-dd format. For example, 2024-01-01.

memoNumberstringOptional
The unique identification number of the debit memo.
postedByIdstringOptional
The ID of the Zuora user who posted the debit memo.
postedOndatetimeOptional

The date and time when the debit memo was posted, in yyyy-mm-dd hh:mm:ss format.

reasonCodestringOptional
A code identifying the reason for the transaction. The value must be an existing reason code or empty.
sequenceSetIdstring or nullOptional

The ID of the sequence set associated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

sourceenumOptional

The source of the debit memo. Possible values:

  • BillRun: The debit memo is generated by a bill run.
  • API
  • ApiSubscribe: The debit memo is created by calling the Create subscription and Create account operation.
  • ApiAmend: The debit memo is created by calling the Update subscription operation.
  • AdhocFromPrpc: The debit memo is created from a product rate plan charge through the Zuora UI or by calling the Create a debit memo from a charge operation.
  • AdhocFromInvoice: The debit memo is created from an invoice or created by reversing an invoice. You can create a debit memo from an invoice through the Zuora UI or by calling the Create a debit memo from an invoice operation.
sourceIdstringOptional

The ID of the debit memo source.

If a debit memo is generated from a bill run, the value is the number of the corresponding bill run. Otherwise, the value is null.

sourceTypeenumOptional
The type of the debit memo source.
statusenumOptional
The status of the debit memo.
targetDatedateOptional

The target date for the debit memo, in yyyy-mm-dd format. For example, 2024-01-01.

taxAmountdoubleOptional
The amount of taxation.
taxMessagestring or nullOptional
The message about the status of tax calculation related to the debit memo. If tax calculation fails in one debit memo, this field displays the reason for the failure.
taxStatusenumOptional

The status of tax calculation related to the debit memo.

Note: This field is only applicable to tax calculation by third-party tax engines. Also, the Voided status indicates that the tax transaction is successfully canceled on the tax vendor’s side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor’s side.

shipToContactSnapshotIdstringOptional

The ID of the ship-to contact snapshot associated with the debit memo.

Note: If you have the Flexible Billing Attributes feature disabled, the value of this field is null.

soldToContactSnapshotIdstringOptional

The ID of the sold-to contact snapshot associated with the debit memo.

Note: If you have the Flexible Billing Attributes feature disabled, the value of this field is null.

taxAutoCalculationbooleanOptionalDefaults to true
Whether to automatically calculate taxes in the debit memo.
totalAmountdoubleOptional
The total amount of the debit memo, including taxes.
totalAmountWithoutTaxdoubleOptional
The total amount of the debit memo, excluding taxes.
totalTaxExemptAmountdoubleOptional
The calculated tax amount excluded due to the exemption.
transferredToAccountingenumOptional
Whether the debit memo was transferred to an external accounting system. This field is used for integration with accounting systems such as NetSuite.
Allowed values:
invoiceIdstringOptional
The ID of a referred invoice.
accountIdstringOptional
The ID of the customer account associated with the debit memo.
paymentTermstringOptional

The name of the payment term assoicated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

accountobjectOptional
billToContactobjectOptional
debitMemoItemslist of objectsOptional
billToContactSnapshotobjectOptional
soldToContactSnapshotobjectOptional
shipToContactSnapshotobjectOptional

Errors

4XX
Client Request Error
500
Internal Server Error